---
product: "AG Grid"
title: "Set Filter - API"
description: "This section describes how the Set Filter can be controlled programmatically using API calls."
enterprise: true
framework: javascript
version: "36.2.0"
related:
    - title: "Filter List"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/filter-set-filter-list/"
    - title: "Data Updates"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/filter-set-data-updates/"
    - title: "Tree List"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/filter-set-tree-list/"
    - title: "Mini Filter"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/filter-set-mini-filter/"
    - title: "Excel Mode"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/filter-set-excel-mode/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Set Filter - API

This section describes how the Set Filter can be controlled programmatically using API calls.

## Set Filter Model

Get and set the state of the Set Filter by getting and setting the model on the grid API.

```js
// get filter model
const model = api.getColumnFilterModel('country');

// set filter model and update
await api.setColumnFilterModel('country', { values: ['Spain', 'Ireland', 'South Africa'] });

// refresh rows based on the filter (not automatic to allow for batching multiple filters)
api.onFilterChanged();
```

The filter model contains an array of string values where each item in the array corresponds to an element to be selected from the set.

Properties available on the `SetFilterModel` interface.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `filterType` | `'set'` |  |  |  |
| `values` | `SetFilterModelValue` |  |  |  |

When values are taken from the grid (the default, with no `filterParams.values` supplied), the model is reconciled against the values currently in the data when it is set. Any selected values that are not present are dropped and not retained: if those values later appear in the data they are not re-selected. Supply `filterParams.values` to keep selections for values that are not currently in the data. See [Refreshing Values](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/filter-set-filter-list/#refreshing-values) and the [Excel Mode](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/filter-set-excel-mode/) comparison.

> **Note**
>
> This value-level reconciliation is distinct from `setFilterModel` being applied asynchronously when inferring cell data types. With initially empty row data, the cell data types cannot be resolved, so the whole `setFilterModel` call is deferred until row data is added (set `cellDataType` to `false` or to an explicit value on every column to apply it synchronously). That defers the entire call once; it does not retain individual values that are absent from the data.

## Set Filter API

The Set Filter consists of two parts - the Set Filter UI (the UI component) and the Set Filter Handler (maintains the values and performs the filter logic).

Note that the Set Filter will always use a filter handler, regardless of whether `enableFilterHandlers` is enabled (which controls filter handlers for [Custom Filter Components](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/component-filter/)).

The Set Filter values can be updated via the Set Filter Handler:

```js
// get filter handler
const countryFilterHandler = api.getColumnFilterHandler('country');
```

The `SetFilterHandler` interface defines the public API for the Set Filter Handler.

Properties available on the `SetFilterHandler&lt;TValue = string&gt;` interface.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `getFilterKeys` | `Function` |  |  |  |
| `getFilterValues` | `Function` |  |  |  |
| `setFilterValues` | `Function` |  |  |  |
| `refreshFilterValues` | `Function` |  |  |  |
| `resetFilterValues` | `Function` |  |  |  |

The Mini Filter can be interacted with via the Set Filter UI instance:

```js
// get filter UI instance
api.getColumnFilterInstance('country').then(countryFilterComponent => {
    // use set filter UI instance
});
```

The `SetFilterUi` interface defines the public API for the Set Filter UI component.

Properties available on the `SetFilterUi&lt;TValue = string&gt;` interface.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `getMiniFilter` | `Function` |  |  |  |
| `setMiniFilter` | `Function` |  |  |  |
| `getFilterHandler` | `Function` |  |  |  |

In the example below, you can see how the filter for the Athlete column is modified through the API.

#### Set Filter API

```ts
import {
  ClientSideRowModelModule,
  FirstDataRenderedEvent,
  GridApi,
  GridOptions,
  ISetFilterParams,
  KeyCreatorParams,
  ModuleRegistry,
  NumberFilterModule,
  SetFilterHandler,
  ValueFormatterParams,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ContextMenuModule,
  FiltersToolPanelModule,
  SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  FiltersToolPanelModule,
  ColumnMenuModule,
  ContextMenuModule,
  SetFilterModule,
  NumberFilterModule,
]);

let gridApi: GridApi<IOlympicData>;

const gridOptions: GridOptions<IOlympicData> = {
  columnDefs: [
    {
      field: "athlete",
      filter: "agSetColumnFilter",
    },
    {
      field: "country",
      valueFormatter: (params: ValueFormatterParams) => {
        return `${params.value.name} (${params.value.code})`;
      },
      keyCreator: countryKeyCreator,
      filterParams: {
        valueFormatter: (params: ValueFormatterParams) => params.value.name,
      } as ISetFilterParams,
    },
    { field: "age", maxWidth: 120, filter: "agNumberColumnFilter" },
    { field: "year", maxWidth: 120 },
    { field: "date" },
    { field: "sport" },
    { field: "gold", filter: "agNumberColumnFilter" },
    { field: "silver", filter: "agNumberColumnFilter" },
    { field: "bronze", filter: "agNumberColumnFilter" },
    { field: "total", filter: "agNumberColumnFilter" },
  ],
  defaultColDef: {
    flex: 1,
    minWidth: 160,
    filter: true,
  },
  sideBar: "filters",
  onFirstDataRendered: onFirstDataRendered,
};

function countryKeyCreator(params: KeyCreatorParams) {
  return params.value.name;
}

function patchData(data: any[]) {
  // hack the data, replace each country with an object of country name and code
  data.forEach((row) => {
    const countryName = row.country;
    const countryCode = countryName.substring(0, 2).toUpperCase();
    row.country = {
      name: countryName,
      code: countryCode,
    };
  });
}

function selectJohnAndKenny() {
  gridApi!
    .setColumnFilterModel("athlete", {
      values: ["John Joe Nevin", "Kenny Egan"],
    })
    .then(() => {
      gridApi!.onFilterChanged();
    });
}

function selectEverything() {
  gridApi!.setColumnFilterModel("athlete", null).then(() => {
    gridApi!.onFilterChanged();
  });
}

function selectNothing() {
  gridApi!.setColumnFilterModel("athlete", { values: [] }).then(() => {
    gridApi!.onFilterChanged();
  });
}

function setCountriesToFranceAustralia() {
  const handler =
    gridApi!.getColumnFilterHandler<
      SetFilterHandler<{ name: string; code: string }>
    >("country");
  handler!.setFilterValues([
    {
      name: "France",
      code: "FR",
    },
    {
      name: "Australia",
      code: "AU",
    },
  ]);
}

function setCountriesToAll() {
  const handler =
    gridApi!.getColumnFilterHandler<
      SetFilterHandler<{ name: string; code: string }>
    >("country");
  handler!.resetFilterValues();
}

function onFirstDataRendered(params: FirstDataRenderedEvent) {
  params.api.getToolPanelInstance("filters")!.expandFilters();
}

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then(function (data) {
    patchData(data);
    gridApi!.setGridOption("rowData", data);
  });

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).selectJohnAndKenny = selectJohnAndKenny;
  (<any>window).selectEverything = selectEverything;
  (<any>window).selectNothing = selectNothing;
  (<any>window).setCountriesToFranceAustralia = setCountriesToFranceAustralia;
  (<any>window).setCountriesToAll = setCountriesToAll;
}
```

[Live example: Set Filter API](https://www.ag-grid.com/archive/36.2.0/examples/filter-set-api/set-filter-api/typescript/)

### Enabling Case-Sensitivity

By default the API is case-insensitive. You can enable case sensitivity by using the `caseSensitive: true` filter parameter:

```js
const gridOptions = {
    columnDefs: [
        {
            field: 'colour',
            filter: 'agSetColumnFilter',
            filterParams: {
                caseSensitive: true
            }
        }
    ],

    // other grid options ...
}
```

> **Note**
>
> The `caseSensitive` option also affects [Mini-Filter](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/filter-set-mini-filter/#enabling-case-sensitive-searches) searches and the values presented in the [Filter List](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/filter-set-filter-list/#enabling-value-case-sensitivity).

The following example demonstrates the difference in behaviour between `caseSensitive: false` (the default) and `caseSensitive: true`:

- With `caseSensitive: false` (the default):
  - `setModel()` will perform **case-insensitive** matching against available values to decide what is enabled in the Filter List.
  - `setFilterValues()` will override the available values and force the case of the presented values in the Filter List to those provided.
    - Selected values will be maintained based upon **case-insensitive** matching.
- With `caseSensitive: true`:
  - `setModel()` will perform **case-sensitive** matching against available values to decide what is enabled in the Filter List.
  - `setFilterValues()` will override the available values and force the case of the presented values in the Filter List to those provided.
    - Selected values will be maintained based upon **case-sensitive** matching.
- In both cases `getModel()` and `getFilterValues()` will return the values with casing that matches those displayed in the Filter List. This is printed to the developer console.

#### Set Filter API - Case Sensitivity

```ts
import {
  ClientSideRowModelModule,
  FirstDataRenderedEvent,
  GridApi,
  GridOptions,
  ICellRendererParams,
  ISetFilterParams,
  ModuleRegistry,
  SetFilterHandler,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ContextMenuModule,
  FiltersToolPanelModule,
  SetFilterModule,
} from "ag-grid-enterprise";
import { getData } from "./data";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  FiltersToolPanelModule,
  ColumnMenuModule,
  ContextMenuModule,
  SetFilterModule,
]);

let gridApi: GridApi;

const gridOptions: GridOptions = {
  columnDefs: [
    {
      headerName: "Case Insensitive (default)",
      field: "colour",
      filter: "agSetColumnFilter",
      filterParams: {
        caseSensitive: false,
        cellRenderer: colourCellRenderer,
      } as ISetFilterParams,
    },
    {
      headerName: "Case Sensitive",
      field: "colour",
      filter: "agSetColumnFilter",
      filterParams: {
        caseSensitive: true,
        cellRenderer: colourCellRenderer,
      } as ISetFilterParams,
    },
  ],
  defaultColDef: {
    flex: 1,
    minWidth: 225,
    cellRenderer: colourCellRenderer,
    floatingFilter: true,
  },
  sideBar: "filters",
  onFirstDataRendered: onFirstDataRendered,
  rowData: getData(),
};

const FIXED_STYLES =
  "vertical-align: middle; border: 1px solid black; margin: 3px; display: inline-block; width: 10px; height: 10px";

const FILTER_TYPES: Record<string, string> = {
  insensitive: "colour",
  sensitive: "colour_1",
};

function colourCellRenderer(params: ICellRendererParams) {
  if (!params.value || params.value === "(Select All)") {
    return params.value;
  }

  return `<div style="background-color: ${params.value.toLowerCase()}; ${FIXED_STYLES}"></div>${params.value}`;
}

function setModel(type: string) {
  gridApi!
    .setColumnFilterModel(FILTER_TYPES[type], { values: MANGLED_COLOURS })
    .then(() => {
      gridApi!.onFilterChanged();
    });
}

function getModel(type: string) {
  console.log(
    JSON.stringify(gridApi!.getColumnFilterModel(FILTER_TYPES[type]), null, 2),
  );
}

function setFilterValues(type: string) {
  const handler = gridApi!.getColumnFilterHandler<SetFilterHandler>(
    FILTER_TYPES[type],
  );
  handler!.setFilterValues(MANGLED_COLOURS);
}

function getValues(type: string) {
  const handler = gridApi!.getColumnFilterHandler<SetFilterHandler>(
    FILTER_TYPES[type],
  );
  console.log(JSON.stringify(handler!.getFilterValues(), null, 2));
}

function reset(type: string) {
  const handler = gridApi!.getColumnFilterHandler<SetFilterHandler>(
    FILTER_TYPES[type],
  );
  handler!.resetFilterValues();
  gridApi!.setColumnFilterModel(FILTER_TYPES[type], null).then(() => {
    gridApi!.onFilterChanged();
  });
}

var MANGLED_COLOURS = ["ReD", "OrAnGe", "WhItE", "YeLlOw"];

function onFirstDataRendered(params: FirstDataRenderedEvent) {
  params.api.getToolPanelInstance("filters")!.expandFilters();
}

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).setModel = setModel;
  (<any>window).getModel = getModel;
  (<any>window).setFilterValues = setFilterValues;
  (<any>window).getValues = getValues;
  (<any>window).reset = reset;
}
```

[Live example: Set Filter API - Case Sensitivity](https://www.ag-grid.com/archive/36.2.0/examples/filter-set-api/set-filter-api-case-sensitive/typescript/)


---
product: "AG Grid"
title: "Set Filter - API"
description: "This section describes how the Set Filter can be controlled programmatically using API calls."
enterprise: true
framework: angular
version: "36.2.0"
related:
    - title: "Filter List"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/filter-set-filter-list/"
    - title: "Data Updates"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/filter-set-data-updates/"
    - title: "Tree List"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/filter-set-tree-list/"
    - title: "Mini Filter"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/filter-set-mini-filter/"
    - title: "Excel Mode"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/filter-set-excel-mode/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Set Filter - API

This section describes how the Set Filter can be controlled programmatically using API calls.

## Set Filter Model

Get and set the state of the Set Filter by getting and setting the model on the grid API.

```js
// get filter model
const model = api.getColumnFilterModel('country');

// set filter model and update
await api.setColumnFilterModel('country', { values: ['Spain', 'Ireland', 'South Africa'] });

// refresh rows based on the filter (not automatic to allow for batching multiple filters)
api.onFilterChanged();
```

The filter model contains an array of string values where each item in the array corresponds to an element to be selected from the set.

Properties available on the `SetFilterModel` interface.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `filterType` | `'set'` |  |  |  |
| `values` | `SetFilterModelValue` |  |  |  |

When values are taken from the grid (the default, with no `filterParams.values` supplied), the model is reconciled against the values currently in the data when it is set. Any selected values that are not present are dropped and not retained: if those values later appear in the data they are not re-selected. Supply `filterParams.values` to keep selections for values that are not currently in the data. See [Refreshing Values](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/filter-set-filter-list/#refreshing-values) and the [Excel Mode](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/filter-set-excel-mode/) comparison.

> **Note**
>
> This value-level reconciliation is distinct from `setFilterModel` being applied asynchronously when inferring cell data types. With initially empty row data, the cell data types cannot be resolved, so the whole `setFilterModel` call is deferred until row data is added (set `cellDataType` to `false` or to an explicit value on every column to apply it synchronously). That defers the entire call once; it does not retain individual values that are absent from the data.

## Set Filter API

The Set Filter consists of two parts - the Set Filter UI (the UI component) and the Set Filter Handler (maintains the values and performs the filter logic).

Note that the Set Filter will always use a filter handler, regardless of whether `enableFilterHandlers` is enabled (which controls filter handlers for [Custom Filter Components](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/component-filter/)).

The Set Filter values can be updated via the Set Filter Handler:

```ts
// get filter handler
const countryFilterHandler = this.gridApi.getColumnFilterHandler('country');
```

The `SetFilterHandler` interface defines the public API for the Set Filter Handler.

Properties available on the `SetFilterHandler&lt;TValue = string&gt;` interface.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `getFilterKeys` | `Function` |  |  |  |
| `getFilterValues` | `Function` |  |  |  |
| `setFilterValues` | `Function` |  |  |  |
| `refreshFilterValues` | `Function` |  |  |  |
| `resetFilterValues` | `Function` |  |  |  |

The Mini Filter can be interacted with via the Set Filter UI instance:

```ts
// get filter UI instance
this.gridApi.getColumnFilterInstance('country').then(countryFilterComponent => {
    // use set filter UI instance
});
```

The `SetFilterUi` interface defines the public API for the Set Filter UI component.

Properties available on the `SetFilterUi&lt;TValue = string&gt;` interface.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `getMiniFilter` | `Function` |  |  |  |
| `setMiniFilter` | `Function` |  |  |  |
| `getFilterHandler` | `Function` |  |  |  |

In the example below, you can see how the filter for the Athlete column is modified through the API.

#### Set Filter API

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  FirstDataRenderedEvent,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ISetFilterParams,
  KeyCreatorParams,
  ModuleRegistry,
  NumberFilterModule,
  SetFilterHandler,
  SideBarDef,
  ValueFormatterParams,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ContextMenuModule,
  FiltersToolPanelModule,
  SetFilterModule,
} from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  FiltersToolPanelModule,
  ColumnMenuModule,
  ContextMenuModule,
  SetFilterModule,
  NumberFilterModule,
]);
import { IOlympicData } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<div class="example-wrapper">
    <div class="example-header">
      <div>
        Athlete:
        <button (click)="selectNothing()">API: Filter empty set</button>
        <button (click)="selectJohnAndKenny()">
          API: Filter only John Joe Nevin and Kenny Egan
        </button>
        <button (click)="selectEverything()">API: Remove filter</button>
      </div>
      <div style="padding-top: 10px">
        Country - available filter values
        <button (click)="setCountriesToFranceAustralia()">
          Filter values restricted to France and Australia
        </button>
        <button (click)="setCountriesToAll()">
          Make all countries available
        </button>
      </div>
    </div>
    <ag-grid-angular
      style="width: 100%; height: 100%;"
      [columnDefs]="columnDefs"
      [defaultColDef]="defaultColDef"
      [sideBar]="sideBar"
      [rowData]="rowData"
      (firstDataRendered)="onFirstDataRendered($event)"
      (gridReady)="onGridReady($event)"
    />
  </div> `,
})
export class AppComponent {
  private gridApi!: GridApi<IOlympicData>;

  columnDefs: ColDef[] = [
    {
      field: "athlete",
      filter: "agSetColumnFilter",
    },
    {
      field: "country",
      valueFormatter: (params: ValueFormatterParams) => {
        return `${params.value.name} (${params.value.code})`;
      },
      keyCreator: countryKeyCreator,
      filterParams: {
        valueFormatter: (params: ValueFormatterParams) => params.value.name,
      } as ISetFilterParams,
    },
    { field: "age", maxWidth: 120, filter: "agNumberColumnFilter" },
    { field: "year", maxWidth: 120 },
    { field: "date" },
    { field: "sport" },
    { field: "gold", filter: "agNumberColumnFilter" },
    { field: "silver", filter: "agNumberColumnFilter" },
    { field: "bronze", filter: "agNumberColumnFilter" },
    { field: "total", filter: "agNumberColumnFilter" },
  ];
  defaultColDef: ColDef = {
    flex: 1,
    minWidth: 160,
    filter: true,
  };
  sideBar: SideBarDef | string | string[] | boolean | null = "filters";
  rowData!: IOlympicData[];

  constructor(private http: HttpClient) {}

  onFirstDataRendered(params: FirstDataRenderedEvent) {
    params.api.getToolPanelInstance("filters")!.expandFilters();
  }

  selectJohnAndKenny() {
    this.gridApi
      .setColumnFilterModel("athlete", {
        values: ["John Joe Nevin", "Kenny Egan"],
      })
      .then(() => {
        this.gridApi.onFilterChanged();
      });
  }

  selectEverything() {
    this.gridApi.setColumnFilterModel("athlete", null).then(() => {
      this.gridApi.onFilterChanged();
    });
  }

  selectNothing() {
    this.gridApi.setColumnFilterModel("athlete", { values: [] }).then(() => {
      this.gridApi.onFilterChanged();
    });
  }

  setCountriesToFranceAustralia() {
    const handler = this.gridApi.getColumnFilterHandler<
      SetFilterHandler<{
        name: string;
        code: string;
      }>
    >("country");
    handler!.setFilterValues([
      {
        name: "France",
        code: "FR",
      },
      {
        name: "Australia",
        code: "AU",
      },
    ]);
  }

  setCountriesToAll() {
    const handler = this.gridApi.getColumnFilterHandler<
      SetFilterHandler<{
        name: string;
        code: string;
      }>
    >("country");
    handler!.resetFilterValues();
  }

  onGridReady(params: GridReadyEvent<IOlympicData>) {
    this.gridApi = params.api;

    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .subscribe((data) => {
        patchData(data);
        this.rowData = data;
      });
  }
}

function countryKeyCreator(params: KeyCreatorParams) {
  return params.value.name;
}
function patchData(data: any[]) {
  // hack the data, replace each country with an object of country name and code
  data.forEach((row) => {
    const countryName = row.country;
    const countryCode = countryName.substring(0, 2).toUpperCase();
    row.country = {
      name: countryName,
      code: countryCode,
    };
  });
}
```

[Live example: Set Filter API](https://www.ag-grid.com/archive/36.2.0/examples/filter-set-api/set-filter-api/angular/)

### Enabling Case-Sensitivity

By default the API is case-insensitive. You can enable case sensitivity by using the `caseSensitive: true` filter parameter:

```ts
<ag-grid-angular
    [columnDefs]="columnDefs"
    /* other grid options ... */ />

this.columnDefs = [
    {
        field: 'colour',
        filter: 'agSetColumnFilter',
        filterParams: {
            caseSensitive: true
        }
    }
];
```

> **Note**
>
> The `caseSensitive` option also affects [Mini-Filter](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/filter-set-mini-filter/#enabling-case-sensitive-searches) searches and the values presented in the [Filter List](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/filter-set-filter-list/#enabling-value-case-sensitivity).

The following example demonstrates the difference in behaviour between `caseSensitive: false` (the default) and `caseSensitive: true`:

- With `caseSensitive: false` (the default):
  - `setModel()` will perform **case-insensitive** matching against available values to decide what is enabled in the Filter List.
  - `setFilterValues()` will override the available values and force the case of the presented values in the Filter List to those provided.
    - Selected values will be maintained based upon **case-insensitive** matching.
- With `caseSensitive: true`:
  - `setModel()` will perform **case-sensitive** matching against available values to decide what is enabled in the Filter List.
  - `setFilterValues()` will override the available values and force the case of the presented values in the Filter List to those provided.
    - Selected values will be maintained based upon **case-sensitive** matching.
- In both cases `getModel()` and `getFilterValues()` will return the values with casing that matches those displayed in the Filter List. This is printed to the developer console.

#### Set Filter API - Case Sensitivity

```ts
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  FirstDataRenderedEvent,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ICellRendererParams,
  ISetFilterParams,
  ModuleRegistry,
  SetFilterHandler,
  SideBarDef,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ContextMenuModule,
  FiltersToolPanelModule,
  SetFilterModule,
} from "ag-grid-enterprise";
import { getData } from "./data";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  FiltersToolPanelModule,
  ColumnMenuModule,
  ContextMenuModule,
  SetFilterModule,
]);

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<div class="example-wrapper">
    <div class="example-header">
      <div>
        Case Insensitive:
        <button (click)="setModel('insensitive')">
          API: setModel() - mismatching case
        </button>
        <button (click)="getModel('insensitive')">API: getModel()</button>
        <button (click)="setFilterValues('insensitive')">
          API: setFilterValues() - mismatching case
        </button>
        <button (click)="getValues('insensitive')">
          API: getFilterValues()
        </button>
        <button (click)="reset('insensitive')">Reset</button>
      </div>
      <div style="padding-top: 10px">
        Case Sensitive:
        <button (click)="setModel('sensitive')">
          API: setModel() - mismatching case
        </button>
        <button (click)="getModel('sensitive')">API: getModel()</button>
        <button (click)="setFilterValues('sensitive')">
          API: setFilterValues() - mismatching case
        </button>
        <button (click)="getValues('sensitive')">API: getFilterValues()</button>
        <button (click)="reset('sensitive')">Reset</button>
      </div>
    </div>
    <ag-grid-angular
      style="width: 100%; height: 100%;"
      [columnDefs]="columnDefs"
      [defaultColDef]="defaultColDef"
      [sideBar]="sideBar"
      [rowData]="rowData"
      (firstDataRendered)="onFirstDataRendered($event)"
      (gridReady)="onGridReady($event)"
    />
  </div> `,
})
export class AppComponent {
  private gridApi!: GridApi;

  columnDefs: ColDef[] = [
    {
      headerName: "Case Insensitive (default)",
      field: "colour",
      filter: "agSetColumnFilter",
      filterParams: {
        caseSensitive: false,
        cellRenderer: colourCellRenderer,
      } as ISetFilterParams,
    },
    {
      headerName: "Case Sensitive",
      field: "colour",
      filter: "agSetColumnFilter",
      filterParams: {
        caseSensitive: true,
        cellRenderer: colourCellRenderer,
      } as ISetFilterParams,
    },
  ];
  defaultColDef: ColDef = {
    flex: 1,
    minWidth: 225,
    cellRenderer: colourCellRenderer,
    floatingFilter: true,
  };
  sideBar: SideBarDef | string | string[] | boolean | null = "filters";
  rowData: any[] | null = getData();

  onFirstDataRendered(params: FirstDataRenderedEvent) {
    params.api.getToolPanelInstance("filters")!.expandFilters();
  }

  setModel(type: string) {
    this.gridApi
      .setColumnFilterModel(FILTER_TYPES[type], { values: MANGLED_COLOURS })
      .then(() => {
        this.gridApi.onFilterChanged();
      });
  }

  getModel(type: string) {
    console.log(
      JSON.stringify(
        this.gridApi.getColumnFilterModel(FILTER_TYPES[type]),
        null,
        2,
      ),
    );
  }

  setFilterValues(type: string) {
    const handler = this.gridApi.getColumnFilterHandler<SetFilterHandler>(
      FILTER_TYPES[type],
    );
    handler!.setFilterValues(MANGLED_COLOURS);
  }

  getValues(type: string) {
    const handler = this.gridApi.getColumnFilterHandler<SetFilterHandler>(
      FILTER_TYPES[type],
    );
    console.log(JSON.stringify(handler!.getFilterValues(), null, 2));
  }

  reset(type: string) {
    const handler = this.gridApi.getColumnFilterHandler<SetFilterHandler>(
      FILTER_TYPES[type],
    );
    handler!.resetFilterValues();
    this.gridApi.setColumnFilterModel(FILTER_TYPES[type], null).then(() => {
      this.gridApi.onFilterChanged();
    });
  }

  onGridReady(params: GridReadyEvent) {
    this.gridApi = params.api;
  }
}

const FIXED_STYLES =
  "vertical-align: middle; border: 1px solid black; margin: 3px; display: inline-block; width: 10px; height: 10px";
const FILTER_TYPES: Record<string, string> = {
  insensitive: "colour",
  sensitive: "colour_1",
};
function colourCellRenderer(params: ICellRendererParams) {
  if (!params.value || params.value === "(Select All)") {
    return params.value;
  }
  return `<div style="background-color: ${params.value.toLowerCase()}; ${FIXED_STYLES}"></div>${params.value}`;
}
var MANGLED_COLOURS = ["ReD", "OrAnGe", "WhItE", "YeLlOw"];
```

[Live example: Set Filter API - Case Sensitivity](https://www.ag-grid.com/archive/36.2.0/examples/filter-set-api/set-filter-api-case-sensitive/angular/)


---
product: "AG Grid"
title: "Set Filter - API"
description: "This section describes how the Set Filter can be controlled programmatically using API calls."
enterprise: true
framework: vue
version: "36.2.0"
related:
    - title: "Filter List"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/filter-set-filter-list/"
    - title: "Data Updates"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/filter-set-data-updates/"
    - title: "Tree List"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/filter-set-tree-list/"
    - title: "Mini Filter"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/filter-set-mini-filter/"
    - title: "Excel Mode"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/filter-set-excel-mode/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Set Filter - API

This section describes how the Set Filter can be controlled programmatically using API calls.

## Set Filter Model

Get and set the state of the Set Filter by getting and setting the model on the grid API.

```js
// get filter model
const model = api.getColumnFilterModel('country');

// set filter model and update
await api.setColumnFilterModel('country', { values: ['Spain', 'Ireland', 'South Africa'] });

// refresh rows based on the filter (not automatic to allow for batching multiple filters)
api.onFilterChanged();
```

The filter model contains an array of string values where each item in the array corresponds to an element to be selected from the set.

Properties available on the `SetFilterModel` interface.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `filterType` | `'set'` |  |  |  |
| `values` | `SetFilterModelValue` |  |  |  |

When values are taken from the grid (the default, with no `filterParams.values` supplied), the model is reconciled against the values currently in the data when it is set. Any selected values that are not present are dropped and not retained: if those values later appear in the data they are not re-selected. Supply `filterParams.values` to keep selections for values that are not currently in the data. See [Refreshing Values](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/filter-set-filter-list/#refreshing-values) and the [Excel Mode](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/filter-set-excel-mode/) comparison.

> **Note**
>
> This value-level reconciliation is distinct from `setFilterModel` being applied asynchronously when inferring cell data types. With initially empty row data, the cell data types cannot be resolved, so the whole `setFilterModel` call is deferred until row data is added (set `cellDataType` to `false` or to an explicit value on every column to apply it synchronously). That defers the entire call once; it does not retain individual values that are absent from the data.

## Set Filter API

The Set Filter consists of two parts - the Set Filter UI (the UI component) and the Set Filter Handler (maintains the values and performs the filter logic).

Note that the Set Filter will always use a filter handler, regardless of whether `enableFilterHandlers` is enabled (which controls filter handlers for [Custom Filter Components](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/component-filter/)).

The Set Filter values can be updated via the Set Filter Handler:

```ts
// get filter handler
const countryFilterHandler = this.gridApi.getColumnFilterHandler('country');
```

The `SetFilterHandler` interface defines the public API for the Set Filter Handler.

Properties available on the `SetFilterHandler&lt;TValue = string&gt;` interface.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `getFilterKeys` | `Function` |  |  |  |
| `getFilterValues` | `Function` |  |  |  |
| `setFilterValues` | `Function` |  |  |  |
| `refreshFilterValues` | `Function` |  |  |  |
| `resetFilterValues` | `Function` |  |  |  |

The Mini Filter can be interacted with via the Set Filter UI instance:

```ts
// get filter UI instance
this.gridApi.getColumnFilterInstance('country').then(countryFilterComponent => {
    // use set filter UI instance
});
```

The `SetFilterUi` interface defines the public API for the Set Filter UI component.

Properties available on the `SetFilterUi&lt;TValue = string&gt;` interface.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `getMiniFilter` | `Function` |  |  |  |
| `setMiniFilter` | `Function` |  |  |  |
| `getFilterHandler` | `Function` |  |  |  |

In the example below, you can see how the filter for the Athlete column is modified through the API.

#### Set Filter API

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  FirstDataRenderedEvent,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ISetFilterParams,
  KeyCreatorParams,
  ModuleRegistry,
  NumberFilterModule,
  SetFilterHandler,
  SideBarDef,
  ValueFormatterParams,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ContextMenuModule,
  FiltersToolPanelModule,
  SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  FiltersToolPanelModule,
  ColumnMenuModule,
  ContextMenuModule,
  SetFilterModule,
  NumberFilterModule,
]);

function countryKeyCreator(params: KeyCreatorParams) {
  return params.value.name;
}

function patchData(data: any[]) {
  // hack the data, replace each country with an object of country name and code
  data.forEach((row) => {
    const countryName = row.country;
    const countryCode = countryName.substring(0, 2).toUpperCase();
    row.country = {
      name: countryName,
      code: countryCode,
    };
  });
}

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div class="example-wrapper">
      <div class="example-header">
        <div>
          Athlete:
          <button v-on:click="selectNothing()">API: Filter empty set</button>
          <button v-on:click="selectJohnAndKenny()">API: Filter only John Joe Nevin and Kenny Egan</button>
          <button v-on:click="selectEverything()">API: Remove filter</button>
        </div>
        <div style="padding-top: 10px">
          Country - available filter values
          <button v-on:click="setCountriesToFranceAustralia()">Filter values restricted to France and Australia</button>
          <button v-on:click="setCountriesToAll()">Make all countries available</button>
        </div>
      </div>
      <ag-grid-vue
        style="width: 100%; height: 100%;"
        @grid-ready="onGridReady"
        :columnDefs="columnDefs"
        :defaultColDef="defaultColDef"
        :sideBar="sideBar"
        :rowData="rowData"
        @first-data-rendered="onFirstDataRendered"></ag-grid-vue>
      </div>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
    const columnDefs = ref<ColDef[]>([
      {
        field: "athlete",
        filter: "agSetColumnFilter",
      },
      {
        field: "country",
        valueFormatter: (params: ValueFormatterParams) => {
          return `${params.value.name} (${params.value.code})`;
        },
        keyCreator: countryKeyCreator,
        filterParams: {
          valueFormatter: (params: ValueFormatterParams) => params.value.name,
        } as ISetFilterParams,
      },
      { field: "age", maxWidth: 120, filter: "agNumberColumnFilter" },
      { field: "year", maxWidth: 120 },
      { field: "date" },
      { field: "sport" },
      { field: "gold", filter: "agNumberColumnFilter" },
      { field: "silver", filter: "agNumberColumnFilter" },
      { field: "bronze", filter: "agNumberColumnFilter" },
      { field: "total", filter: "agNumberColumnFilter" },
    ]);
    const defaultColDef = ref<ColDef>({
      flex: 1,
      minWidth: 160,
      filter: true,
    });
    const sideBar = ref<SideBarDef | string | string[] | boolean | null>(
      "filters",
    );
    const rowData = ref<IOlympicData[]>(null);

    function onFirstDataRendered(params: FirstDataRenderedEvent) {
      params.api.getToolPanelInstance("filters")!.expandFilters();
    }
    function selectJohnAndKenny() {
      gridApi
        .value!.setColumnFilterModel("athlete", {
          values: ["John Joe Nevin", "Kenny Egan"],
        })
        .then(() => {
          gridApi.value!.onFilterChanged();
        });
    }
    function selectEverything() {
      gridApi.value!.setColumnFilterModel("athlete", null).then(() => {
        gridApi.value!.onFilterChanged();
      });
    }
    function selectNothing() {
      gridApi
        .value!.setColumnFilterModel("athlete", { values: [] })
        .then(() => {
          gridApi.value!.onFilterChanged();
        });
    }
    function setCountriesToFranceAustralia() {
      const handler = gridApi.value!.getColumnFilterHandler<
        SetFilterHandler<{
          name: string;
          code: string;
        }>
      >("country");
      handler!.setFilterValues([
        {
          name: "France",
          code: "FR",
        },
        {
          name: "Australia",
          code: "AU",
        },
      ]);
    }
    function setCountriesToAll() {
      const handler = gridApi.value!.getColumnFilterHandler<
        SetFilterHandler<{
          name: string;
          code: string;
        }>
      >("country");
      handler!.resetFilterValues();
    }
    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      const updateData = (data) => {
        patchData(data);
        rowData.value = data;
      };

      fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => updateData(data));
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      sideBar,
      rowData,
      onGridReady,
      onFirstDataRendered,
      selectJohnAndKenny,
      selectEverything,
      selectNothing,
      setCountriesToFranceAustralia,
      setCountriesToAll,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Set Filter API](https://www.ag-grid.com/archive/36.2.0/examples/filter-set-api/set-filter-api/vue3/)

### Enabling Case-Sensitivity

By default the API is case-insensitive. You can enable case sensitivity by using the `caseSensitive: true` filter parameter:

```ts
<ag-grid-vue
    :columnDefs="columnDefs"
    /* other grid options ... */>
</ag-grid-vue>

this.columnDefs = [
    {
        field: 'colour',
        filter: 'agSetColumnFilter',
        filterParams: {
            caseSensitive: true
        }
    }
];
```

> **Note**
>
> The `caseSensitive` option also affects [Mini-Filter](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/filter-set-mini-filter/#enabling-case-sensitive-searches) searches and the values presented in the [Filter List](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/filter-set-filter-list/#enabling-value-case-sensitivity).

The following example demonstrates the difference in behaviour between `caseSensitive: false` (the default) and `caseSensitive: true`:

- With `caseSensitive: false` (the default):
  - `setModel()` will perform **case-insensitive** matching against available values to decide what is enabled in the Filter List.
  - `setFilterValues()` will override the available values and force the case of the presented values in the Filter List to those provided.
    - Selected values will be maintained based upon **case-insensitive** matching.
- With `caseSensitive: true`:
  - `setModel()` will perform **case-sensitive** matching against available values to decide what is enabled in the Filter List.
  - `setFilterValues()` will override the available values and force the case of the presented values in the Filter List to those provided.
    - Selected values will be maintained based upon **case-sensitive** matching.
- In both cases `getModel()` and `getFilterValues()` will return the values with casing that matches those displayed in the Filter List. This is printed to the developer console.

#### Set Filter API - Case Sensitivity

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  FirstDataRenderedEvent,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ICellRendererParams,
  ISetFilterParams,
  ModuleRegistry,
  SetFilterHandler,
  SideBarDef,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ContextMenuModule,
  FiltersToolPanelModule,
  SetFilterModule,
} from "ag-grid-enterprise";
import { getData } from "./data";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  FiltersToolPanelModule,
  ColumnMenuModule,
  ContextMenuModule,
  SetFilterModule,
]);

const FIXED_STYLES =
  "vertical-align: middle; border: 1px solid black; margin: 3px; display: inline-block; width: 10px; height: 10px";

const FILTER_TYPES: Record<string, string> = {
  insensitive: "colour",
  sensitive: "colour_1",
};

function colourCellRenderer(params: ICellRendererParams) {
  if (!params.value || params.value === "(Select All)") {
    return params.value;
  }
  return `<div style="background-color: ${params.value.toLowerCase()}; ${FIXED_STYLES}"></div>${params.value}`;
}

var MANGLED_COLOURS = ["ReD", "OrAnGe", "WhItE", "YeLlOw"];

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div class="example-wrapper">
      <div class="example-header">
        <div>
          Case Insensitive:
          <button v-on:click="setModel('insensitive')">API: setModel() - mismatching case</button>
          <button v-on:click="getModel('insensitive')">API: getModel()</button>
          <button v-on:click="setFilterValues('insensitive')">API: setFilterValues() - mismatching case</button>
          <button v-on:click="getValues('insensitive')">API: getFilterValues()</button>
          <button v-on:click="reset('insensitive')">Reset</button>
        </div>
        <div style="padding-top: 10px">
          Case Sensitive:
          <button v-on:click="setModel('sensitive')">API: setModel() - mismatching case</button>
          <button v-on:click="getModel('sensitive')">API: getModel()</button>
          <button v-on:click="setFilterValues('sensitive')">API: setFilterValues() - mismatching case</button>
          <button v-on:click="getValues('sensitive')">API: getFilterValues()</button>
          <button v-on:click="reset('sensitive')">Reset</button>
        </div>
      </div>
      <ag-grid-vue
        style="width: 100%; height: 100%;"
        @grid-ready="onGridReady"
        :columnDefs="columnDefs"
        :defaultColDef="defaultColDef"
        :sideBar="sideBar"
        :rowData="rowData"
        @first-data-rendered="onFirstDataRendered"></ag-grid-vue>
      </div>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi | null>(null);
    const columnDefs = ref<ColDef[]>([
      {
        headerName: "Case Insensitive (default)",
        field: "colour",
        filter: "agSetColumnFilter",
        filterParams: {
          caseSensitive: false,
          cellRenderer: colourCellRenderer,
        } as ISetFilterParams,
      },
      {
        headerName: "Case Sensitive",
        field: "colour",
        filter: "agSetColumnFilter",
        filterParams: {
          caseSensitive: true,
          cellRenderer: colourCellRenderer,
        } as ISetFilterParams,
      },
    ]);
    const defaultColDef = ref<ColDef>({
      flex: 1,
      minWidth: 225,
      cellRenderer: colourCellRenderer,
      floatingFilter: true,
    });
    const sideBar = ref<SideBarDef | string | string[] | boolean | null>(
      "filters",
    );
    const rowData = ref<any[] | null>(getData());

    function onFirstDataRendered(params: FirstDataRenderedEvent) {
      params.api.getToolPanelInstance("filters")!.expandFilters();
    }
    function setModel(type: string) {
      gridApi
        .value!.setColumnFilterModel(FILTER_TYPES[type], {
          values: MANGLED_COLOURS,
        })
        .then(() => {
          gridApi.value!.onFilterChanged();
        });
    }
    function getModel(type: string) {
      console.log(
        JSON.stringify(
          gridApi.value!.getColumnFilterModel(FILTER_TYPES[type]),
          null,
          2,
        ),
      );
    }
    function setFilterValues(type: string) {
      const handler = gridApi.value!.getColumnFilterHandler<SetFilterHandler>(
        FILTER_TYPES[type],
      );
      handler!.setFilterValues(MANGLED_COLOURS);
    }
    function getValues(type: string) {
      const handler = gridApi.value!.getColumnFilterHandler<SetFilterHandler>(
        FILTER_TYPES[type],
      );
      console.log(JSON.stringify(handler!.getFilterValues(), null, 2));
    }
    function reset(type: string) {
      const handler = gridApi.value!.getColumnFilterHandler<SetFilterHandler>(
        FILTER_TYPES[type],
      );
      handler!.resetFilterValues();
      gridApi.value!.setColumnFilterModel(FILTER_TYPES[type], null).then(() => {
        gridApi.value!.onFilterChanged();
      });
    }
    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      sideBar,
      rowData,
      onGridReady,
      onFirstDataRendered,
      setModel,
      getModel,
      setFilterValues,
      getValues,
      reset,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Set Filter API - Case Sensitivity](https://www.ag-grid.com/archive/36.2.0/examples/filter-set-api/set-filter-api-case-sensitive/vue3/)


---
product: "AG Grid"
title: "Set Filter - API"
description: "This section describes how the Set Filter can be controlled programmatically using API calls."
enterprise: true
framework: react
version: "36.2.0"
related:
    - title: "Filter List"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/filter-set-filter-list/"
    - title: "Data Updates"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/filter-set-data-updates/"
    - title: "Tree List"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/filter-set-tree-list/"
    - title: "Mini Filter"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/filter-set-mini-filter/"
    - title: "Excel Mode"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/filter-set-excel-mode/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Set Filter - API

This section describes how the Set Filter can be controlled programmatically using API calls.

## Set Filter Model

Get and set the state of the Set Filter by getting and setting the model on the grid API.

```js
// get filter model
const model = api.getColumnFilterModel('country');

// set filter model and update
await api.setColumnFilterModel('country', { values: ['Spain', 'Ireland', 'South Africa'] });

// refresh rows based on the filter (not automatic to allow for batching multiple filters)
api.onFilterChanged();
```

The filter model contains an array of string values where each item in the array corresponds to an element to be selected from the set.

Properties available on the `SetFilterModel` interface.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `filterType` | `'set'` |  |  |  |
| `values` | `SetFilterModelValue` |  |  |  |

When values are taken from the grid (the default, with no `filterParams.values` supplied), the model is reconciled against the values currently in the data when it is set. Any selected values that are not present are dropped and not retained: if those values later appear in the data they are not re-selected. Supply `filterParams.values` to keep selections for values that are not currently in the data. See [Refreshing Values](https://www.ag-grid.com/archive/36.2.0/react-data-grid/filter-set-filter-list/#refreshing-values) and the [Excel Mode](https://www.ag-grid.com/archive/36.2.0/react-data-grid/filter-set-excel-mode/) comparison.

> **Note**
>
> This value-level reconciliation is distinct from `setFilterModel` being applied asynchronously when inferring cell data types. With initially empty row data, the cell data types cannot be resolved, so the whole `setFilterModel` call is deferred until row data is added (set `cellDataType` to `false` or to an explicit value on every column to apply it synchronously). That defers the entire call once; it does not retain individual values that are absent from the data.

## Set Filter API

The Set Filter consists of two parts - the Set Filter UI (the UI component) and the Set Filter Handler (maintains the values and performs the filter logic).

Note that the Set Filter will always use a filter handler, regardless of whether `enableFilterHandlers` is enabled (which controls filter handlers for [Custom Filter Components](https://www.ag-grid.com/archive/36.2.0/react-data-grid/component-filter/)).

The Set Filter values can be updated via the Set Filter Handler:

```jsx
// get filter handler
const countryFilterHandler = gridApi.getColumnFilterHandler('country');
```

The `SetFilterHandler` interface defines the public API for the Set Filter Handler.

Properties available on the `SetFilterHandler&lt;TValue = string&gt;` interface.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `getFilterKeys` | `Function` |  |  |  |
| `getFilterValues` | `Function` |  |  |  |
| `setFilterValues` | `Function` |  |  |  |
| `refreshFilterValues` | `Function` |  |  |  |
| `resetFilterValues` | `Function` |  |  |  |

The Mini Filter can be interacted with via the Set Filter UI instance:

```jsx
// get filter UI instance
gridApi.getColumnFilterInstance('country').then(countryFilterComponent => {
    // use set filter UI instance
});
```

The `SetFilterUi` interface defines the public API for the Set Filter UI component.

Properties available on the `SetFilterUi&lt;TValue = string&gt;` interface.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `getMiniFilter` | `Function` |  |  |  |
| `setMiniFilter` | `Function` |  |  |  |
| `getFilterHandler` | `Function` |  |  |  |

In the example below, you can see how the filter for the Athlete column is modified through the API.

#### Set Filter API

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  FirstDataRenderedEvent,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ISetFilterParams,
  KeyCreatorParams,
  ModuleRegistry,
  NumberFilterModule,
  SetFilterHandler,
  SideBarDef,
  ValueFormatterParams,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ContextMenuModule,
  FiltersToolPanelModule,
  SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  ClientSideRowModelModule,
  FiltersToolPanelModule,
  ColumnMenuModule,
  ContextMenuModule,
  SetFilterModule,
  NumberFilterModule,
];

function countryKeyCreator(params: KeyCreatorParams) {
  return params.value.name;
}

function patchData(data: any[]) {
  // hack the data, replace each country with an object of country name and code
  data.forEach((row) => {
    const countryName = row.country;
    const countryCode = countryName.substring(0, 2).toUpperCase();
    row.country = {
      name: countryName,
      code: countryCode,
    };
  });
}

const GridExample = () => {
  const gridRef = useRef<AgGridReact<IOlympicData>>(null);
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [rowData, setRowData] = useState<IOlympicData[]>();
  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    {
      field: "athlete",
      filter: "agSetColumnFilter",
    },
    {
      field: "country",
      valueFormatter: (params: ValueFormatterParams) => {
        return `${params.value.name} (${params.value.code})`;
      },
      keyCreator: countryKeyCreator,
      filterParams: {
        valueFormatter: (params: ValueFormatterParams) => params.value.name,
      } as ISetFilterParams,
    },
    { field: "age", maxWidth: 120, filter: "agNumberColumnFilter" },
    { field: "year", maxWidth: 120 },
    { field: "date" },
    { field: "sport" },
    { field: "gold", filter: "agNumberColumnFilter" },
    { field: "silver", filter: "agNumberColumnFilter" },
    { field: "bronze", filter: "agNumberColumnFilter" },
    { field: "total", filter: "agNumberColumnFilter" },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      flex: 1,
      minWidth: 160,
      filter: true,
    };
  }, []);

  const onGridReady = useCallback((params: GridReadyEvent) => {
    fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .then((resp) => resp.json())
      .then((data: IOlympicData[]) => {
        patchData(data);
        setRowData(data);
      });
  }, []);

  const onFirstDataRendered = useCallback((params: FirstDataRenderedEvent) => {
    params.api.getToolPanelInstance("filters")!.expandFilters();
  }, []);

  const selectJohnAndKenny = useCallback(() => {
    gridRef
      .current!.api.setColumnFilterModel("athlete", {
        values: ["John Joe Nevin", "Kenny Egan"],
      })
      .then(() => {
        gridRef.current!.api.onFilterChanged();
      });
  }, []);

  const selectEverything = useCallback(() => {
    gridRef.current!.api.setColumnFilterModel("athlete", null).then(() => {
      gridRef.current!.api.onFilterChanged();
    });
  }, []);

  const selectNothing = useCallback(() => {
    gridRef
      .current!.api.setColumnFilterModel("athlete", { values: [] })
      .then(() => {
        gridRef.current!.api.onFilterChanged();
      });
  }, []);

  const setCountriesToFranceAustralia = useCallback(() => {
    const handler = gridRef.current!.api.getColumnFilterHandler<
      SetFilterHandler<{
        name: string;
        code: string;
      }>
    >("country");
    handler!.setFilterValues([
      {
        name: "France",
        code: "FR",
      },
      {
        name: "Australia",
        code: "AU",
      },
    ]);
  }, []);

  const setCountriesToAll = useCallback(() => {
    const handler = gridRef.current!.api.getColumnFilterHandler<
      SetFilterHandler<{
        name: string;
        code: string;
      }>
    >("country");
    handler!.resetFilterValues();
  }, []);

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div className="example-wrapper">
          <div className="example-header">
            <div>
              Athlete:
              <button onClick={selectNothing}>API: Filter empty set</button>
              <button onClick={selectJohnAndKenny}>
                API: Filter only John Joe Nevin and Kenny Egan
              </button>
              <button onClick={selectEverything}>API: Remove filter</button>
            </div>
            <div style={{ paddingTop: "10px" }}>
              Country - available filter values
              <button onClick={setCountriesToFranceAustralia}>
                Filter values restricted to France and Australia
              </button>
              <button onClick={setCountriesToAll}>
                Make all countries available
              </button>
            </div>
          </div>

          <div style={gridStyle}>
            <AgGridReact<IOlympicData>
              ref={gridRef}
              rowData={rowData}
              columnDefs={columnDefs}
              defaultColDef={defaultColDef}
              sideBar={"filters"}
              onGridReady={onGridReady}
              onFirstDataRendered={onFirstDataRendered}
            />
          </div>
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Set Filter API](https://www.ag-grid.com/archive/36.2.0/examples/filter-set-api/set-filter-api/reactFunctionalTs/)

### Enabling Case-Sensitivity

By default the API is case-insensitive. You can enable case sensitivity by using the `caseSensitive: true` filter parameter:

```jsx
const [columnDefs, setColumnDefs] = useState([
    {
        field: 'colour',
        filter: 'agSetColumnFilter',
        filterParams: {
            caseSensitive: true
        }
    }
]);

<AgGridReact columnDefs={columnDefs} />
```

> **Note**
>
> The `caseSensitive` option also affects [Mini-Filter](https://www.ag-grid.com/archive/36.2.0/react-data-grid/filter-set-mini-filter/#enabling-case-sensitive-searches) searches and the values presented in the [Filter List](https://www.ag-grid.com/archive/36.2.0/react-data-grid/filter-set-filter-list/#enabling-value-case-sensitivity).

The following example demonstrates the difference in behaviour between `caseSensitive: false` (the default) and `caseSensitive: true`:

- With `caseSensitive: false` (the default):
  - `setModel()` will perform **case-insensitive** matching against available values to decide what is enabled in the Filter List.
  - `setFilterValues()` will override the available values and force the case of the presented values in the Filter List to those provided.
    - Selected values will be maintained based upon **case-insensitive** matching.
- With `caseSensitive: true`:
  - `setModel()` will perform **case-sensitive** matching against available values to decide what is enabled in the Filter List.
  - `setFilterValues()` will override the available values and force the case of the presented values in the Filter List to those provided.
    - Selected values will be maintained based upon **case-sensitive** matching.
- In both cases `getModel()` and `getFilterValues()` will return the values with casing that matches those displayed in the Filter List. This is printed to the developer console.

#### Set Filter API - Case Sensitivity

```tsx
'use client';
import React, {
  StrictMode,
  useCallback,
  useMemo,
  useRef,
  useState,
} from "react";
import { createRoot } from "react-dom/client";

import type {
  ColDef,
  FirstDataRenderedEvent,
  SetFilterHandler,
} from "ag-grid-community";
import {
  ClientSideRowModelModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ContextMenuModule,
  FiltersToolPanelModule,
  SetFilterModule,
} from "ag-grid-enterprise";
import type { CustomCellRendererProps } from "ag-grid-react";
import { AgGridProvider, AgGridReact } from "ag-grid-react";

import { getData } from "./data";
import "./styles.css";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  ClientSideRowModelModule,
  SetFilterModule,
  ColumnMenuModule,
  ContextMenuModule,
  FiltersToolPanelModule,
];

const colourCellRenderer = (props: CustomCellRendererProps) => {
  if (!props.value || props.value === "(Select All)") {
    return props.value;
  }

  const styles = {
    verticalAlign: "middle",
    border: "1px solid black",
    margin: 3,
    display: "inline-block",
    width: 10,
    height: 10,
    backgroundColor: props.value.toLowerCase(),
  };
  return (
    <React.Fragment>
      <div style={styles} />
      {props.value}
    </React.Fragment>
  );
};

const FILTER_TYPES: Record<string, string> = {
  insensitive: "colour",
  sensitive: "colour_1",
};

const MANGLED_COLOURS = ["ReD", "OrAnGe", "WhItE", "YeLlOw"];

const GridExample = () => {
  const gridRef = useRef<AgGridReact>(null);
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [rowData, setRowData] = useState(getData());
  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    {
      headerName: "Case Insensitive (default)",
      field: "colour",
      filter: "agSetColumnFilter",
      filterParams: {
        caseSensitive: false,
        cellRenderer: colourCellRenderer,
      },
    },
    {
      headerName: "Case Sensitive",
      field: "colour",
      filter: "agSetColumnFilter",
      filterParams: {
        caseSensitive: true,
        cellRenderer: colourCellRenderer,
      },
    },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      flex: 1,
      minWidth: 225,
      cellRenderer: colourCellRenderer,
      floatingFilter: true,
    };
  }, []);

  const onFirstDataRendered = useCallback((params: FirstDataRenderedEvent) => {
    gridRef.current!.api.getToolPanelInstance("filters")!.expandFilters();
  }, []);

  const setModel = useCallback((type: string) => {
    gridRef
      .current!.api.setColumnFilterModel(FILTER_TYPES[type], {
        values: MANGLED_COLOURS,
      })
      .then(() => {
        gridRef.current!.api.onFilterChanged();
      });
  }, []);

  const getModel = useCallback((type: string) => {
    console.log(
      JSON.stringify(
        gridRef.current!.api.getColumnFilterModel(FILTER_TYPES[type]),
        null,
        2,
      ),
    );
  }, []);

  const setFilterValues = useCallback((type: string) => {
    const handler =
      gridRef.current!.api.getColumnFilterHandler<SetFilterHandler>(
        FILTER_TYPES[type],
      );
    handler!.setFilterValues(MANGLED_COLOURS);
  }, []);

  const getValues = useCallback((type: string) => {
    const handler =
      gridRef.current!.api.getColumnFilterHandler<SetFilterHandler>(
        FILTER_TYPES[type],
      );
    console.log(JSON.stringify(handler!.getFilterValues(), null, 2));
  }, []);

  const reset = useCallback((type: string) => {
    const handler =
      gridRef.current!.api.getColumnFilterHandler<SetFilterHandler>(
        FILTER_TYPES[type],
      );
    handler!.resetFilterValues();
    gridRef
      .current!.api.setColumnFilterModel(FILTER_TYPES[type], null)
      .then(() => {
        gridRef.current!.api.onFilterChanged();
      });
  }, []);

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div className="example-wrapper">
          <div className="example-header">
            <div>
              Case Insensitive:
              <button onClick={() => setModel("insensitive")}>
                API: setModel() - mismatching case
              </button>
              <button onClick={() => getModel("insensitive")}>
                API: getModel()
              </button>
              <button onClick={() => setFilterValues("insensitive")}>
                API: setFilterValues() - mismatching case
              </button>
              <button onClick={() => getValues("insensitive")}>
                API: getFilterValues()
              </button>
              <button onClick={() => reset("insensitive")}>Reset</button>
            </div>
            <div style={{ paddingTop: "10px" }}>
              Case Sensitive:
              <button onClick={() => setModel("sensitive")}>
                API: setModel() - mismatching case
              </button>
              <button onClick={() => getModel("sensitive")}>
                API: getModel()
              </button>
              <button onClick={() => setFilterValues("sensitive")}>
                API: setFilterValues() - mismatching case
              </button>
              <button onClick={() => getValues("sensitive")}>
                API: getFilterValues()
              </button>
              <button onClick={() => reset("sensitive")}>Reset</button>
            </div>
          </div>

          <div style={gridStyle}>
            <AgGridReact
              ref={gridRef}
              rowData={rowData}
              columnDefs={columnDefs}
              defaultColDef={defaultColDef}
              sideBar={"filters"}
              onFirstDataRendered={onFirstDataRendered}
            />
          </div>
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Set Filter API - Case Sensitivity](https://www.ag-grid.com/archive/36.2.0/examples/filter-set-api/set-filter-api-case-sensitive/reactFunctionalTs/)
